﻿package 
{
	import flash.display.MovieClip;
	import AccordionListHeader;
	import AccordionListItem;
	import AccordionHeaderEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	/**
	 * ...
	 * @author Jeroen Oliemans
	 */
	public class AccordionList extends MovieClip
	{
		private var accordionData:Array;
		
		public function AccordionList( data:Array )
		{
			accordionData = data;
			
			init();
		}
		
		private function init():void
		{
			buildLayout();
			addEventListeners();
		}
		
		
		private function addEventListeners():void
		{
			addEventListener( AccordionHeaderEvent.HEADER_CLICKED, headerClickHandler );
		}
		
		private function headerClickHandler(e:AccordionHeaderEvent):void 
		{
			setAccordion( e.id );
			var ahe:AccordionHeaderEvent = new AccordionHeaderEvent( AccordionHeaderEvent.UPDATE_SCROLL_BAR );
			ahe.id = e.id;
			dispatchEvent( ahe );
		}
		
		private function setAccordion( id:Number ):void
		{
			var activeHeader:AccordionListHeader = this.getChildAt( id ) as AccordionListHeader;
			
			// reset all headers
			var offSetY:Number = accordionData[ id ].menuItems.length * 20;
			for (var i:int = 0; i < accordionData.length; i++) 
			{
				var resetHeader:AccordionListHeader = this.getChildAt( i ) as AccordionListHeader;
				resetHeader.y = 0 + (i * 25);
				resetHeader.hideItems();
				trace( "hideitem: " + i );
			}
			//offset items below active header
			for (var k:int = id + 1; k < accordionData.length; k++)
			{
				var headersAfterActive:AccordionListHeader = this.getChildAt(k) as AccordionListHeader;
				headersAfterActive.y += offSetY;
			}
			activeHeader.showItems();
		}
		
		private function buildLayout():void
		{
			var nextHeaderY:Number = 0;
			
			for (var i:int = 0; i < accordionData.length; i++) 
			{
				var header:AccordionListHeader = new AccordionListHeader( accordionData[i].menuItems );
				header.x = 0;
				header.id = i;
				header.header_txt.text = accordionData[i].title;
				header.y = 0 + (i * 25) + nextHeaderY;
				addChild( header );		
			}
			// open the first menu
			setAccordion( 0 );
		}
	}
}