﻿package 
{
	import flash.display.MovieClip;
	import AccordionList;
	import AccordionHeaderEvent;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import fl.controls.ScrollBar;
	import fl.events.ScrollEvent;
	
	/**
	 * ...
	 * @author Jeroen Oliemans
	 * @link  http://www.wonderolie.nl
	 */
	public class AccordionListContainer extends MovieClip 
	{
		private var _al:AccordionList;
		private var _almask:Sprite;
		private var _sb:ScrollBar;
		private var accordionData:Array;
		private var maxMenuItems:Number = 0;
		
		public function AccordionListContainer()
		{
			init();
		}
		
		private function buildMaskScroll():void
		{
			_almask = new Sprite();
			_almask.graphics.beginFill( 0xff0000, 0.5 );
			_almask.graphics.drawRect( 0, 0, 150, 150 );
			_almask.graphics.endFill();
			addChild( _almask );
			
			_al.mask = _almask;
			
			_sb = new ScrollBar();
			_sb.x = _al.x + _al.width;
			_sb.y = _al.y;
			_sb.height = _almask.height;
			_sb.enabled = true;
			_sb.setScrollProperties( _almask.height, 0, accordionData[0].menuItems.length*20  );
			_sb.addEventListener( ScrollEvent.SCROLL, scrollHandler );
			
			addChild( _sb );
		}
		
		private function scrollHandler(e:ScrollEvent):void 
		{
			_al.y = -e.position + _almask.y;
		}
		
		private function buildAccordion():void
		{
			_al = new AccordionList( accordionData );
			addChild(_al);
			buildMaskScroll();
		}
		
		private function init():void
		{
			makeData();
			calculateMaxMenuItems();
			//addEventListener( AccordionHeaderEvent.HEADER_CLICKED, headerClickHandler );
			addEventListener( AccordionHeaderEvent.UPDATE_SCROLL_BAR, updateScrollBarHandler );
			
			buildAccordion();
			
		}
		
		private function calculateMaxMenuItems():void
		{
			for (var i:int = 0; i < accordionData.length; i++) 
			{
				var tLength:Number = accordionData[i].menuItems.length;
				if ( tLength > maxMenuItems )
				{
					maxMenuItems = tLength;
				}
			}
			trace( "maxMenuItems " + maxMenuItems  );
		}
		
		
		
		private function updateScrollBarHandler(e:AccordionHeaderEvent):void 
		{
			trace( "AccordionHeaderEvent" + e.id );
			// update scrollbar
			
			_sb.setScrollProperties( _almask.height, 0, accordionData[e.id].menuItems.length*20  );
		}
		
		private function makeData():void
		{
			accordionData = new Array();

			accordionData[0] = { title: "header 1",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4"  ) };
			accordionData[1] = { title: "header 2",  menuItems: new Array( "item 1", "item 2", "item 3"  ) };
			accordionData[2] = { title: "header 3",  menuItems: new Array( "item 1"  ) };
			accordionData[3] = { title: "header 4",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4"  ) };
			accordionData[4] = { title: "header 5",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4", "item 5", "item 6", "item 7"  ) };
			accordionData[5] = { title: "header 6",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4", "item 5", "item 6", "laatste"  ) };
		}
		
	}
	
}