﻿package 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import AccordionListItem;
	import AccordionHeaderEvent;
	import flash.text.TextField;
	
	/**
	 * ...
	 * @author Jeroen Oliemans
	 * @link  http://www.wonderolie.nl
	 */
	public class AccordionListHeader extends MovieClip 
	{
		private var _id:Number;
		private var _items:Array;
		private var _itemsHolder:Sprite;
		
		public function AccordionListHeader( items:Array )
		{
			_items = items;
			
			init();
		}
		
		private function init():void
		{
			makeButton();
			addItemsHolder();
			addItems();
		}
		
		private function addItems():void
		{
			for (var i:int = 0; i < _items.length; i++) 
			{
				var item:AccordionListItem = new AccordionListItem( _items[i] );
				item.x = 0;
				item.y = 25 + (i * 20);
				_itemsHolder.addChild( item );
			}
		}
		
		private function addItemsHolder():void
		{
			_itemsHolder = new Sprite();
			_itemsHolder.graphics.beginFill( 0xff0000 );
			_itemsHolder.graphics.drawRect( this.x, this.y + 25, 150, _items.length * 20 );
			_itemsHolder.graphics.endFill();
			this.addChild( _itemsHolder );
			hideItems();
		}
		
		public function hideItems():void
		{
			_itemsHolder.visible = false;
			this.arrow_mc.rotation = 0;
		}
		
		public function showItems():void
		{
			_itemsHolder.visible = true;
			this.arrow_mc.rotation = 90;
		}
		
		
		private function makeButton():void
		{
			this.buttonMode = true;
			this.useHandCursor = true;
			this.addEventListener( MouseEvent.CLICK, headerClickHandler );
		}
		
		private function headerClickHandler(e:MouseEvent):void 
		{
			var  ahe:AccordionHeaderEvent = new AccordionHeaderEvent( AccordionHeaderEvent.HEADER_CLICKED, true );
			ahe.id = _id;
			dispatchEvent( ahe );
		}
		
		public function get id():Number { return _id; }
		
		public function set id(value:Number):void 
		{
			_id = value;
		}
		
	}
	
}